=== debian/changelog ===
rhash (1.2.6-2) unstable; urgency=low

  * Package compilation is fixed for several archs

 -- Alexey S Kravchenko <rhash.admin@gmail.com>  Thu, 30 Jun 2011 01:04:24 +0700

rhash (1.2.6-1) unstable; urgency=low

  * New upstream release version 1.2.6
   - ABI changed - now librhash0.0 is librhash0
   - OpenSSL support for faster hash calculation if libssl is installed
     (fully optional) for both rhash and librhash0

 -- Alexey S Kravchenko <rhash.admin@gmail.com>  Wed, 15 Jun 2011 01:03:34 +0700

rhash (1.2.5-1) unstable; urgency=low

  * Initial release (Closes: #629614)
  * The library SONAME was changed in the Debian package, see README.Debian

 -- Alexey S Kravchenko <rhash.admin@gmail.com>  Tue, 07 Jun 2011 22:46:05 +0700
