=== debian/control ===
Source: rhash
Section: utils
Priority: optional
Maintainer: Alexey S Kravchenko <rhash.admin@gmail.com>
Build-Depends: debhelper (>= 8), libssl-dev (>= 1.0.0)
Standards-Version: 3.9.2
Homepage: http://rhash.sourceforge.net/
Vcs-Git: https://github.com/rhash/RHash.git
Vcs-Browser: https://github.com/rhash/RHash

Package: rhash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl (>= 1.0.0)
Description: utility for computing hash sums and magnet links
 RHash is a console utility for calculation and verification of magnet links
 and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Output in a predefined (SFV, BSD-like) or a user-defined format.
  * Can calculate Magnet links and EDonkey 2000 links.
  * Updating hash files (adding hash sums of files missing in the hash file).
  * Ability to process directories recursively.
  * Portability: the program works the same on Linux, *BSD or Windows.

Package: librhash0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl (>= 1.0.0)
Description: shared library for hash functions computing
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaniously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash-dev
Architecture: any
Section: libdevel
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: header files of librhash and static library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaniously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for librhash
 LibRHash is a professional, portable, thread-safe C library for computing 
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1/SHA2, AICH,
 ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaniously.
  * Portability: the library works on Linux, *BSD and Windows.
